blob: 9d8bb78b3921bfbd73df975392982b15320d4514 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Thomas Heijligenf579bba2021-10-12 12:48:01 +020031STRIP_ARGS = -s
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000032INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000033DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000034PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000035MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010036CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000037EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000038RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000039PKG_CONFIG ?= pkg-config
40BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000041
Stefan Taunerfd0d4132012-09-25 21:24:55 +000042# The following parameter changes the default programmer that will be used if there is no -p/--programmer
43# argument given when running flashrom. The predefined setting does not enable any default so that every
44# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
45# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
46# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
47# system attached to an external programmer while the default programmer is set to the internal programmer, and
48# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
49# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
51CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000052# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020053CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000054# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020055# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000056# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000057
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000058# If your compiler spits out excessive warnings, run make WARNERROR=no
59# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000060WARNERROR ?= yes
61
62ifeq ($(WARNERROR), yes)
63CFLAGS += -Werror
64endif
65
Stefan Taunere37735a2015-01-26 22:03:35 +000066ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000067PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000068override CPPFLAGS += -I$(LIBS_BASE)/include
69override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000070endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000071
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000073override PKG_CONFIG += --static
74override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075endif
76
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077# Set LC_ALL=C to minimize influences of the locale.
78# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060079# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080LC_ALL=C
81export LC_ALL
82
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000083dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000084
85# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
86# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090087debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
88 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000089
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000090###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020091# Dependency handling.
92
93DEPENDS_ON_SERIAL := \
94 CONFIG_BUSPIRATE_SPI \
95 CONFIG_PONY_SPI \
96 CONFIG_SERPROG \
97
98DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020099 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200100 CONFIG_INTERNAL \
101 CONFIG_NICINTEL_SPI \
102 CONFIG_OGP_SPI \
103 CONFIG_PONY_SPI \
104 CONFIG_RAYER_SPI \
105
106DEPENDS_ON_LIBPCI := \
107 CONFIG_ATAHPT \
108 CONFIG_ATAPROMISE \
109 CONFIG_ATAVIA \
110 CONFIG_DRKAISER \
111 CONFIG_GFXNVIDIA \
112 CONFIG_INTERNAL \
113 CONFIG_IT8212 \
114 CONFIG_NIC3COM \
115 CONFIG_NICINTEL \
116 CONFIG_NICINTEL_EEPROM \
117 CONFIG_NICINTEL_SPI \
118 CONFIG_NICNATSEMI \
119 CONFIG_NICREALTEK \
120 CONFIG_OGP_SPI \
121 CONFIG_SATAMV \
122 CONFIG_SATASII \
123
124DEPENDS_ON_LIBUSB1 := \
125 CONFIG_CH341A_SPI \
126 CONFIG_DEDIPROG \
127 CONFIG_DEVELOPERBOX_SPI \
128 CONFIG_DIGILENT_SPI \
129 CONFIG_PICKIT2_SPI \
130 CONFIG_RAIDEN_DEBUG_SPI \
131 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200132 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200133
134DEPENDS_ON_LIBFTDI := \
135 CONFIG_FT2232_SPI \
136 CONFIG_USBBLASTER_SPI \
137
138DEPENDS_ON_LIBJAYLINK := \
139 CONFIG_JLINK_SPI \
140
Nico Hubera54f5a42021-06-27 14:27:41 +0200141
142ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
143$(call disable_all,$(DEPENDS_ON_LIBUSB1))
144endif
145
146ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
147$(call disable_all,$(DEPENDS_ON_LIBPCI))
148endif
149
Nico Huber7f898972021-06-27 13:30:50 +0200150###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000151# General OS-specific settings.
152# 1. Prepare for later by gathering information about host and target OS
153# 2. Set compiler flags and parameters according to OSes
154# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000155
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000156# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000157HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100158ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000159# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
160CC = gcc
161endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100162
Thomas Heijligen282a9512021-10-12 13:30:06 +0200163# Determine the destination OS, architecture and endian
164# IMPORTANT: The following lines must be placed before TARGET_OS, ARCH or ENDIAN
165# is ever used (of course), but should come after any lines setting CC because
166# the lines below use CC itself.
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200167override TARGET_OS := $(call c_macro_test, Makefile.d/os_test.h)
Thomas Heijligen6efdfb32021-10-12 15:16:46 +0200168override ARCH := $(call c_macro_test, Makefile.d/arch_test.h)
Thomas Heijligen9a2787b2021-10-12 15:54:06 +0200169override ENDIAN := $(call c_macro_test, Makefile.d/endian_test.h)
Thomas Heijligen282a9512021-10-12 13:30:06 +0200170
Thomas Heijligen0bec7b22021-10-12 13:18:15 +0200171ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD OpenBSD DragonFlyBSD))
172override CPPFLAGS += -I/usr/local/include
173override LDFLAGS += -L/usr/local/lib
174endif
175
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000176ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000177override CPPFLAGS += -I/opt/local/include -I/usr/local/include
178override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000179endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000180
Stefan Taunerc65b8552013-09-12 15:48:39 +0000181ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000182# Needs special `pciutils/pci.h` for older NetBSD packages
183PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
184override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000185override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000186endif
187
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000188ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000189EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000190# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000191override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000192LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200193# Missing serial support.
194$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
195# Libraries not available for DOS
196$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000197endif
Ollie Lho184a4042005-11-26 21:55:36 +0000198
Thomas Heijligen847d94b2021-10-12 17:38:01 +0200199ifeq ($(TARGET_OS), $(filter $(TARGET_OS), MinGW Cygwin))
200FEATURE_CFLAGS += -D'IS_WINDOWS=1'
201else
202FEATURE_CFLAGS += -D'IS_WINDOWS=0'
203endif
204
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000205# FIXME: Should we check for Cygwin/MSVC as well?
206ifeq ($(TARGET_OS), MinGW)
207EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000208# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000209FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000210# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000211# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000212FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100213
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000214# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200215$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
216# And programmers that need raw access.
217$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000218
Nico Huberca621782021-06-27 13:53:49 +0200219else # No MinGW
220
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100221# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200222$(call mark_unsupported,CONFIG_NI845X_SPI)
223
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100224endif
225
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000226ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000227ifeq ($(MAKECMDGOALS),)
228.DEFAULT_GOAL := libflashrom.a
229$(info Setting default goal to libflashrom.a)
230endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000231FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200232$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000233# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200234$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000235# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200236$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100237# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200238$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000239endif
240
Nico Huberdc8e54a2021-06-27 14:17:34 +0200241# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200242ifneq ($(TARGET_OS), $(filter $(TARGET_OS), Linux Android))
Nico Huberdc8e54a2021-06-27 14:17:34 +0200243$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
244$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000245endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000246
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000247ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200248# Android on x86 (currently) does not provide raw PCI port I/O operations.
249$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000250endif
251
Nico Huberc8801732017-12-01 18:19:43 +0000252# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200253ifneq ($(ARCH)-little, $(filter $(ARCH), x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200254$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000255endif
256
Thomas Heijligend6d96c12021-10-12 16:47:43 +0200257ifeq ($(ENDIAN), little)
258FEATURE_CFLAGS += -D'__FLASHROM_LITTLE_ENDIAN__=1'
259endif
260ifeq ($(ENDIAN), big)
261FEATURE_CFLAGS += -D'__FLASHROM_BIG_ENDIAN__=1'
262endif
263
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000264# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000265# Right now this means the drivers below only work on x86.
266ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200267$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
268$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
269$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000270endif
271
Nico Huber8945b812021-06-27 14:24:53 +0200272# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
273# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000274# Right now those architectures are alpha hppa m68k sh s390
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200275ifneq ($(ARCH), $(filter $(ARCH), x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200276$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
277$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
278$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000279endif
280
Thomas Heijligen433dc1c2021-10-12 17:58:35 +0200281ifeq ($(TARGET_OS), $(filter $(TARGET_OS), Linux Darwin NetBSD OpenBSD))
282FEATURE_CFLAGS += -D'USE_IOPL=1'
283else
284FEATURE_CFLAGS += -D'USE_IOPL=0'
285endif
286
287ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD FreeBSD-glibc DragonFlyBSD))
288FEATURE_CFLAGS += -D'USE_DEV_IO=1'
289else
290FEATURE_CFLAGS += -D'USE_DEV_IO=0'
291endif
292
293ifeq ($(TARGET_OS), $(filter $(TARGET_OS), Hurd))
294FEATURE_CFLAGS += -D'USE_IOPERM=1'
295else
296FEATURE_CFLAGS += -D'USE_IOPERM=0'
297endif
298
299
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000300###############################################################################
301# Flash chip drivers and bus support infrastructure.
302
Stefan Tauner4404f732013-09-12 08:28:56 +0000303CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000304 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300305 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100306 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
307 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000308
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000309###############################################################################
310# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000311
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200312LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000313
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000314###############################################################################
315# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000316
Stefan Tauner9b32de92014-08-08 23:52:33 +0000317CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000318
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200319# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
320# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
321# be obtained using util/getrevision.sh, which is the common case during development.
322-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200323VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200324MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000325
Stefan Tauner76347082016-11-27 17:45:49 +0100326SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000327
Stefan Tauner76347082016-11-27 17:45:49 +0100328# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100329ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100330$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100331endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000332
Stefan Tauner037cd842013-08-25 00:10:56 +0000333###############################################################################
334# Default settings of CONFIG_* variables.
335
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000336# Always enable internal/onboard support for now.
337CONFIG_INTERNAL ?= yes
338
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000339# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000340CONFIG_SERPROG ?= yes
341
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000342# RayeR SPIPGM hardware support
343CONFIG_RAYER_SPI ?= yes
344
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000345# PonyProg2000 SPI hardware support
346CONFIG_PONY_SPI ?= yes
347
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000348# Always enable 3Com NICs for now.
349CONFIG_NIC3COM ?= yes
350
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000351# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
352CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000353
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000354# Always enable SiI SATA controllers for now.
355CONFIG_SATASII ?= yes
356
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000357# Highpoint (HPT) ATA/RAID controller support.
358# IMPORTANT: This code is not yet working!
359CONFIG_ATAHPT ?= no
360
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000361# VIA VT6421A LPC memory support
362CONFIG_ATAVIA ?= yes
363
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000364# Promise ATA controller support.
365CONFIG_ATAPROMISE ?= no
366
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000367# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000368CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000369
James Lairdc60de0e2013-03-27 13:00:23 +0000370# Always enable Altera USB-Blaster dongles for now.
371CONFIG_USBBLASTER_SPI ?= yes
372
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000373# MSTAR DDC support needs more tests/reviews/cleanups.
374CONFIG_MSTARDDC_SPI ?= no
375
Justin Chevrier66e554b2015-02-08 21:58:10 +0000376# Always enable PICkit2 SPI dongles for now.
377CONFIG_PICKIT2_SPI ?= yes
378
Miklós Márton324929c2019-08-01 19:14:10 +0200379# Always enable STLink V3
380CONFIG_STLINKV3_SPI ?= yes
381
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000382# Always enable dummy tracing for now.
383CONFIG_DUMMY ?= yes
384
385# Always enable Dr. Kaiser for now.
386CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000387
Joerg Fischer5665ef32010-05-21 21:54:07 +0000388# Always enable Realtek NICs for now.
389CONFIG_NICREALTEK ?= yes
390
Andrew Morganc29c2e72010-06-07 22:37:54 +0000391# Disable National Semiconductor NICs until support is complete and tested.
392CONFIG_NICNATSEMI ?= no
393
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000394# Always enable Intel NICs for now.
395CONFIG_NICINTEL ?= yes
396
Idwer Vollering004f4b72010-09-03 18:21:21 +0000397# Always enable SPI on Intel NICs for now.
398CONFIG_NICINTEL_SPI ?= yes
399
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000400# Always enable EEPROM on Intel NICs for now.
401CONFIG_NICINTEL_EEPROM ?= yes
402
Mark Marshall90021f22010-12-03 14:48:11 +0000403# Always enable SPI on OGP cards for now.
404CONFIG_OGP_SPI ?= yes
405
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000406# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000407CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000408
Simon Glassae616512016-01-23 23:27:58 +0000409# Always enable Dediprog SF100 for now.
410CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000411
Daniel Thompson45e91a22018-06-04 13:46:29 +0100412# Always enable Developerbox emergency recovery for now.
413CONFIG_DEVELOPERBOX_SPI ?= yes
414
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000415# Always enable Marvell SATA controllers for now.
416CONFIG_SATAMV ?= yes
417
David Hendricksf9a30552015-05-23 20:30:30 -0700418# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
419CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000420CONFIG_LINUX_SPI ?= yes
421
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000422# Always enable ITE IT8212F PATA controllers for now.
423CONFIG_IT8212 ?= yes
424
Urja Rannikko0870b022016-01-31 22:10:29 +0000425# Winchiphead CH341A
426CONFIG_CH341A_SPI ?= yes
427
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100428# Digilent Development board JTAG
429CONFIG_DIGILENT_SPI ?= yes
430
Jean THOMASe28d8e42022-10-11 17:54:30 +0200431# DirtyJTAG
432CONFIG_DIRTYJTAG_SPI ?= yes
433
Marc Schink3578ec62016-03-17 16:23:03 +0100434# Disable J-Link for now.
435CONFIG_JLINK_SPI ?= no
436
Nico Huber83d52072021-06-27 00:07:13 +0200437# National Instruments USB-845x is Windows only and needs a proprietary library.
438CONFIG_NI845X_SPI ?= no
439
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000440# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000441CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000442
Stefan Taunerf3503372016-02-26 23:51:21 +0000443# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
444ifeq ($(CONFIG_NOTHING), yes)
445 ifeq ($(CONFIG_EVERYTHING), yes)
446 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
447 endif
448 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
449 $(if $(filter yes, $($(var))),\
450 $(eval $(var)=no)))
451endif
452
Patrick Georgiced7ab62015-01-19 19:52:34 +0000453# Enable all features if CONFIG_EVERYTHING=yes is given
454ifeq ($(CONFIG_EVERYTHING), yes)
455$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
456 $(if $(filter no, $($(var))),\
457 $(eval $(var)=yes)))
458endif
459
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000460# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200461
462ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200463override CONFIG_BITBANG_SPI = yes
464else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000465CONFIG_BITBANG_SPI ?= no
466endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000467
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000468###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000469# Handle CONFIG_* variables that depend on others set (and verified) above.
470
471# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
472ifeq ($(TARGET_OS), libpayload)
473ifeq ($(CONFIG_INTERNAL), yes)
474ifeq ($(CONFIG_INTERNAL_DMI), no)
475UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
476else
477override CONFIG_INTERNAL_DMI = yes
478endif
479endif
480endif
481
482# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
483CONFIG_INTERNAL_DMI ?= yes
484
485###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000486# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000487# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000488
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200489ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
490FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
491else
492FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
493endif
494
Stefan Tauner265fcac2014-06-02 00:12:23 +0000495FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000496
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000497ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000498FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000499PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000500ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000501PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200502PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000503ifeq ($(CONFIG_INTERNAL_DMI), yes)
504FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
505endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000506else
507endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000508endif
509
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000510ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000511FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000512PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000513NEED_SERIAL += CONFIG_SERPROG
514NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000515endif
516
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000517ifeq ($(CONFIG_RAYER_SPI), yes)
518FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
519PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000520NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000521endif
522
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000523ifeq ($(CONFIG_PONY_SPI), yes)
524FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
525PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000526NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000527endif
528
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000529ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000530FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000531PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000532endif
533
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000534ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000535FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000536PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000537endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000538
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000539ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000540FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000541PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000542endif
543
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000544ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000545FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000546PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000547endif
548
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000549ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000550FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000551PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000552endif
553
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000554ifeq ($(CONFIG_ATAVIA), yes)
555FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
556PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000557endif
558
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000559ifeq ($(CONFIG_ATAPROMISE), yes)
560FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
561PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000562endif
563
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000564ifeq ($(CONFIG_IT8212), yes)
565FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
566PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000567endif
568
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000569ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000570# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000571FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000572PROGRAMMER_OBJS += ft2232_spi.o
573endif
574
575ifeq ($(CONFIG_USBBLASTER_SPI), yes)
576# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000577FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000578PROGRAMMER_OBJS += usbblaster_spi.o
579endif
580
Justin Chevrier66e554b2015-02-08 21:58:10 +0000581ifeq ($(CONFIG_PICKIT2_SPI), yes)
582FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
583PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000584endif
585
Miklós Márton324929c2019-08-01 19:14:10 +0200586ifeq ($(CONFIG_STLINKV3_SPI), yes)
587FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
588PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200589endif
590
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000591ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000592FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000593PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000594endif
595
596ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000597FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000598PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000599endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000600
Joerg Fischer5665ef32010-05-21 21:54:07 +0000601ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000602FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000603PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000604endif
605
Andrew Morganc29c2e72010-06-07 22:37:54 +0000606ifeq ($(CONFIG_NICNATSEMI), yes)
607FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
608PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000609endif
610
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000611ifeq ($(CONFIG_NICINTEL), yes)
612FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
613PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000614endif
615
Idwer Vollering004f4b72010-09-03 18:21:21 +0000616ifeq ($(CONFIG_NICINTEL_SPI), yes)
617FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
618PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000619endif
620
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000621ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
622FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
623PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000624endif
625
Mark Marshall90021f22010-12-03 14:48:11 +0000626ifeq ($(CONFIG_OGP_SPI), yes)
627FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
628PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000629endif
630
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000631ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
632FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000633PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000634NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000635endif
636
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000637ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000638FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000639PROGRAMMER_OBJS += dediprog.o
640endif
641
Daniel Thompson45e91a22018-06-04 13:46:29 +0100642ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
643FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
644PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100645endif
646
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000647ifeq ($(CONFIG_SATAMV), yes)
648FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
649PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000650endif
651
David Hendricksf9a30552015-05-23 20:30:30 -0700652ifeq ($(CONFIG_LINUX_MTD), yes)
653# This is a totally ugly hack.
654FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
655PROGRAMMER_OBJS += linux_mtd.o
656endif
657
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000658ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000659# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000660FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000661PROGRAMMER_OBJS += linux_spi.o
662endif
663
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000664ifeq ($(CONFIG_MSTARDDC_SPI), yes)
665# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000666FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000667NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000668PROGRAMMER_OBJS += mstarddc_spi.o
669endif
670
Urja Rannikko0870b022016-01-31 22:10:29 +0000671ifeq ($(CONFIG_CH341A_SPI), yes)
672FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
673PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000674endif
675
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100676ifeq ($(CONFIG_DIGILENT_SPI), yes)
677FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
678PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100679endif
680
Jean THOMASe28d8e42022-10-11 17:54:30 +0200681ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
682FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
683PROGRAMMER_OBJS += dirtyjtag_spi.o
684endif
685
Marc Schink3578ec62016-03-17 16:23:03 +0100686ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100687FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
688PROGRAMMER_OBJS += jlink_spi.o
689endif
690
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100691ifeq ($(CONFIG_NI845X_SPI), yes)
692FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
693
694ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
695# if the user did not specified the NI-845x headers/lib path
696# do a guess for both 32 and 64 bit Windows versions
697NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100698NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200699
700# hack to access env variable containing brackets...
701PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
702
703ifneq ($(PROGRAMFILES_X86DIR),)
704ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
705NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
706NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
707endif
708endif
709
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100710else
711NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
712NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
713endif
714
715FEATURE_CFLAGS += $(NI845X_INCLUDES)
716LIBS += -lni845x
717PROGRAMMER_OBJS += ni845x_spi.o
718endif
719
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000720ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200721LIB_OBJS += serial.o
722ifeq ($(TARGET_OS), Linux)
723LIB_OBJS += custom_baud_linux.o
724else
725LIB_OBJS += custom_baud.o
726endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000727endif
728
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000729ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000730ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000731LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000732endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000733endif
734
Nico Huberf55ca202021-06-27 14:36:06 +0200735NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000736ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000737CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000738# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
739# libpci may need raw memory, MSR or PCI port I/O on some platforms.
740# Individual drivers might have the same needs as well.
741NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000742FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000743FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000744
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000745PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000746ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000747# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000748PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000749else
750PCILIBS += -lpci
751endif
752endif
753
754ifneq ($(NEED_RAW_ACCESS), )
755# Raw memory, MSR or PCI port I/O access.
756FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
757PROGRAMMER_OBJS += physmap.o hwaccess.o
758
759ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200760ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000761PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200762endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000763else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000764ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200765ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000766PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200767endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000768else
769ifeq ($(TARGET_OS), Darwin)
770# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000771PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000772endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000773endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000774endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000775
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000776endif
777
Nico Huberf55ca202021-06-27 14:36:06 +0200778NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000779ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000780CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100781PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000782# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200783ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD DragonFlyBSD))
Stefan Taunere49edbb2016-01-31 22:10:14 +0000784USB1LIBS += -lusb
785else
786ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000787override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000788USB1LIBS += -lusb-1.0
789else
Stefan Tauner45207062016-02-19 08:17:24 +0000790USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
791override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000792endif
793endif
794endif
795
Nico Huberf55ca202021-06-27 14:36:06 +0200796NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200797ifneq ($(NEED_LIBFTDI), )
798FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
799FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
800FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
801FEATURE_CFLAGS += $(FTDI_INCLUDES)
802FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
803# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
804# into a hard requirement for libusb, defeating the purpose of auto-enabling.
805endif
806
Nico Huberf55ca202021-06-27 14:36:06 +0200807NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100808ifneq ($(NEED_LIBJAYLINK), )
809CHECK_LIBJAYLINK = yes
810JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
811override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
812endif
813
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000814ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000815FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000816CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000817endif
818
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000819FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000820
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000821# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000822FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000823
Nico Huber8624e8c2012-11-05 21:46:33 +0100824FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
825FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
826
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000827LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000828OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000829
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000830all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000831ifeq ($(ARCH), x86)
Thomas Heijligen3976b7e2021-10-20 15:55:35 +0200832 @+$(MAKE) -C util/ich_descriptors_tool/ HOST_OS=$(HOST_OS) TARGET_OS=$(TARGET_OS)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000833endif
834
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000835$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100836 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000837
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000838libflashrom.a: $(LIBFLASHROM_OBJS)
839 $(AR) rcs $@ $^
840 $(RANLIB) $@
841
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000842# TAROPTIONS reduces information leakage from the packager's system.
843# If other tar programs support command line arguments for setting uid/gid of
844# stored files, they can be handled here as well.
845TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000846
Paul Fox05dfbe62009-06-16 21:08:06 +0000847%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100848 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000849
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000850# Make sure to add all names of generated binaries here.
851# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000852# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000853clean:
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200854 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a $(filter-out Makefile.d, $(wildcard *.d *.o)) $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000855 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000856
Ollie Lho184a4042005-11-26 21:55:36 +0000857distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000858 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000859
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000860strip: $(PROGRAM)$(EXEC_SUFFIX)
861 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000862
Stefan Tauner56787082011-08-18 02:27:19 +0000863# to define test programs we use verbatim variables, which get exported
864# to environment variables and are referenced with $$<varname> later
865
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000866compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000867 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000868 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000869 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000870 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
871 echo "found." || { echo "not found."; \
872 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000873 @rm -f .test.c .test$(EXEC_SUFFIX)
Thomas Heijligen6efdfb32021-10-12 15:16:46 +0200874 @echo Target arch is $(ARCH)
875 @if [ $(ARCH) = unknown ]; then echo Aborting.; exit 1; fi
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200876 @echo Target OS is $(TARGET_OS)
877 @if [ $(TARGET_OS) = unknown ]; then echo Aborting.; exit 1; fi
Thomas Heijligen9a2787b2021-10-12 15:54:06 +0200878 @echo Target endian is $(ENDIAN)
879 @if [ $(ENDIAN) = unknown ]; then echo Aborting.; exit 1; fi
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000880ifeq ($(TARGET_OS), libpayload)
881 @$(CC) --version 2>&1 | grep -q coreboot || \
882 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
883 echo "This might work but usually does not, please beware." )
884endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000885
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000886hwlibs: compiler
887 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000888ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000889 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000890 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000891 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000892 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
893 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000894 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000895 echo "Please install libpci headers or disable all features"; \
896 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000897 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000898 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
899 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000900 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000901 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000902 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000903 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000904 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
905 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000906 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000907 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
908 echo "yes." || { echo "no."; \
909 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000910 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
911 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000912 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000913 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000914 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
915 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000916 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000917 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000918 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000919endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000920ifeq ($(CHECK_LIBUSB1), yes)
921 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
922 @echo "$$LIBUSB1_TEST" > .test.c
923 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
924 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
925 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000926 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000927 echo "Please install libusb-1.0 headers or disable all features"; \
928 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000929 echo "See README for more information."; echo; \
930 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
931 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
932 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
933 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
934 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000935 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000936 echo "Please install libusb-1.0 or disable all features"; \
937 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000938 echo "See README for more information."; echo; \
939 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
940 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
941endif
Marc Schink3578ec62016-03-17 16:23:03 +0100942ifeq ($(CHECK_LIBJAYLINK), yes)
943 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
944 @echo "$$LIBJAYLINK_TEST" > .test.c
945 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
946 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
947 echo "found." || { echo "not found."; echo; \
948 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
949 echo "Please install libjaylink headers or disable the feature"; \
950 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
951 echo "See README for more information."; echo; \
952 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
953 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
954 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
955 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
956 echo "yes." || { echo "no."; \
957 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
958 echo "Please install libjaylink or disable the feature"; \
959 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
960 echo "See README for more information."; echo; \
961 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
962 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
963endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000964
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000965.features: features
966
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000967# If a user does not explicitly request a non-working feature, we should
968# silently disable it. However, if a non-working (does not compile) feature
969# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000970# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000971featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000972ifeq ($(PROGRAMMER_OBJS),)
973 @echo "You have to enable at least one programmer driver!"
974 @false
975endif
976ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000977 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
978 @false
979endif
980
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000981features: compiler
982 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000983ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000984 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000985 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000986 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000987 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
988 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
989 printf "Checking for FT232H support in libftdi... " ; \
990 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000991 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000992 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
993 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
994 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
995 ) || \
996 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
997 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000998endif
David Hendricksf9a30552015-05-23 20:30:30 -0700999ifeq ($(CONFIG_LINUX_MTD), yes)
1000 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1001 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1002 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1003 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1004 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1005 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1006 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1007endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001008ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001009 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001010 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001011 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001012 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001013 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001014 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1015 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001016endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001017ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001018 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001019 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001020 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001021 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001022 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001023 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1024 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001025endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001026ifeq ($(CONFIG_NI845X_SPI), yes)
1027 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1028 @echo "$$NI845X_TEST" > .featuretest.c
1029 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1030
1031 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1032 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1033 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1034 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1035 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1036 echo "For the NI-845x 17.0 the library path is:"; \
1037 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1038 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1039 exit 1; }; } \
1040 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1041endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001042 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001043 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001044 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001045 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001046 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001047 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001048 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001049ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1050 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1051 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1052else
Nico Huber8624e8c2012-11-05 21:46:33 +01001053 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1054 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1055 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1056 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1057 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1058 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001059endif
Stefan Tauner56787082011-08-18 02:27:19 +00001060 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1061 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001062
Stefan Tauner4c723152016-01-14 22:47:55 +00001063$(PROGRAM).8.html: $(PROGRAM).8
1064 @groff -mandoc -Thtml $< >$@
1065
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001066$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001067 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001068 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001069
1070install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001071 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001072 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001073 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001074 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001075
Nico Huber454f6132012-12-10 13:34:10 +00001076libinstall: libflashrom.a libflashrom.h
1077 mkdir -p $(DESTDIR)$(PREFIX)/lib
1078 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1079 mkdir -p $(DESTDIR)$(PREFIX)/include
1080 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1081
Nico Huber5f245a22023-01-10 17:14:47 +01001082versioninfo:
1083# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1084 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1085 @echo "VERSION = $(RELEASE)" > $@.inc
1086 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1087
Nico Huber26c2c4d2023-01-10 17:45:38 +01001088branch: versioninfo
1089 @git checkout -b $(RELEASE)
1090 @git add -f $<.inc
1091 @git commit -sm'Update version info for $(RELEASE)'
1092
1093tag: versioninfo
1094 @git add -f $<.inc
1095 @git commit -sm'Update version info for $(RELEASE)'
1096 @git tag -s $(RELEASE)
1097
Nico Huber5f245a22023-01-10 17:14:47 +01001098# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001099RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001100
Nico Huber1d58a902023-01-10 18:26:12 +01001101_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001102_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001103 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1104 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1105 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001106# Generate fresh versioninfo.inc and compare
1107 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1108 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1109 "$(EXPORT_VERSIONINFO)"
1110 @if [ -f versioninfo.inc ]; then \
1111 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1112 { echo Error: Version info changed:; \
1113 cat "$(EXPORT_VERSIONINFO)"; \
1114 echo Update versioninfo.inc and tag accordingly.; \
1115 exit 1; \
1116 }; \
1117 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001118# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1119# sed is required to filter out file names having the attribute set.
1120# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1121# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001122 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1123 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001124 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001125 xargs -0 sh -c 'for f; do \
1126 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001127 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001128 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001129
Stefan Tauner76347082016-11-27 17:45:49 +01001130export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001131 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001132
1133tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001134 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1135 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001136# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001137 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1138 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001139
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001140libpayload: clean
1141 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001142
Felix Singer9441c6e2022-10-21 12:47:11 +02001143gitconfig:
1144 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1145
Nico Huber26c2c4d2023-01-10 17:45:38 +01001146.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001147
Stefan Tauner23e10b82016-01-23 16:16:49 +00001148# Disable implicit suffixes and built-in rules (for performance and profit)
1149.SUFFIXES:
1150
Stefan Reinauere2f01582010-06-07 11:08:07 +00001151-include $(OBJS:.o=.d)